'use strict'

const a = require('assert')
const is = require('@sindresorhus/is')

const validateItem = require('./lib/item')
const validateReference = require('./lib/reference')
const validateMode = require('./lib/mode')

const validateRoute = (valItem, route, name = 'route') => {
  validateItem(route, name)

  a.strictEqual(route.type, 'route', name + '.type must be `route`')

  validateReference(route.id, name + '.id')

  valItem(['line'], route.line, name + '.line')

  if (!is.null(route.mode) && !is.undefined(route.mode)) {
    validateMode(route.mode, name + '.mode')
  }
  if (!is.undefined(route.subMode)) {
    a.fail(name + '.subMode is reserved and should not be used for now')
  }

  a.ok(Array.isArray(route.stops), name + '.stops must be an array')
  for (let i = 0; i < route.stops; i++) {
    const s = route.stops[i]
    valItem(['stop'], s, name + `stops[${i}]`)
  }
}

module.exports = validateRoute
